/*
 * Copyright (C) 2017 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 * http://thema.univ-fcomte.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


package org.thema.fractalopolis;

import org.locationtech.jts.geom.Polygon;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.geom.AffineTransform;
import java.awt.geom.Rectangle2D;
import java.io.File;
import java.io.IOException;
import java.util.Arrays;
import java.util.List;
import java.util.Locale;
import java.util.concurrent.CancellationException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.AbstractAction;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JToggleButton;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import org.geotools.feature.SchemaException;
import org.geotools.geometry.jts.LiteShape;
import org.thema.common.Config;
import org.thema.common.JavaLoader;
import org.thema.common.Util;
import org.thema.common.swing.PreferencesDialog;
import org.thema.common.swing.TaskMonitor;
import org.thema.drawshape.SelectableShape;
import org.thema.drawshape.image.CoverageShape;
import org.thema.drawshape.layer.DefaultGroupLayer;
import org.thema.drawshape.layer.FeatureLayer;
import org.thema.drawshape.layer.Layer;
import org.thema.drawshape.layer.RasterLayer;
import org.thema.drawshape.layer.ShapeFileLayer;
import org.thema.drawshape.style.FeatureStyle;
import org.thema.drawshape.style.RasterStyle;
import org.thema.drawshape.style.table.UniqueColorTable;
import org.thema.fractalopolis.Project.Layers;
import org.thema.fractalopolis.access.AccessibilitiesDialog;
import org.thema.fractalopolis.ifs.FractalElem;
import org.thema.fractalopolis.ifs.FractalElemShape;


/**
 * Main frame and entry point of Fractalopolis software.
 * 
 * @author  Gilles Vuidel
 */
public final class App extends javax.swing.JFrame {

    /** global access to the main frame */
    public static App mainFrame;
    
    private Project project;
    
    private DefaultGroupLayer layers, largeScaleLayers, fineScaleLayers;
    private StatInfoDialog largeMonDlg, fineMonDlg;
    private JToggleButton limitToggleButton, overlapToggleButton;
    
    /** Creates new Fractalopolis main frame */
    public App() {
    
        setTitle("Fractalopolis " + JavaLoader.getVersion(App.class));
        initComponents();

        mapViewer.getMap().setMultipleSelection(false);
        mapViewer.putExportButton();
        mapViewer.putAddLayerButton();
        
        limitToggleButton = new javax.swing.JToggleButton(limitAction);
        overlapToggleButton = new javax.swing.JToggleButton(overlapAction);
        mapViewer.addCustomButton(limitToggleButton);
        mapViewer.addCustomButton(overlapToggleButton);
        overlapToggleButton.setSelected(true);
        limitToggleButton.setSelected(true);
        
        mapViewer.addCustomButton(new JButton(editShapeAction));
        
        setLocationRelativeTo(null);
        
        Config.setProgressBar(mapViewer.getProgressBar());
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        mapViewer = new org.thema.drawshape.ui.MapViewer();
        menuBar = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        newMenuItem = new javax.swing.JMenuItem();
        openMenuItem = new javax.swing.JMenuItem();
        setLayerMenuItem = new javax.swing.JMenuItem();
        saveMenuItem = new javax.swing.JMenuItem();
        saveasMenuItem = new javax.swing.JMenuItem();
        closeMenuItem = new javax.swing.JMenuItem();
        prefMenuItem = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        exitMenuItem = new javax.swing.JMenuItem();
        largeScaleMenu = new javax.swing.JMenu();
        largeIfsMenuItem = new javax.swing.JMenuItem();
        largeAccessMenuItem = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JPopupMenu.Separator();
        statWinMenuItem = new javax.swing.JMenuItem();
        importXmlMenuItem = new javax.swing.JMenuItem();
        fineScaleMenu = new javax.swing.JMenu();
        createFineScaleMenuItem = new javax.swing.JMenuItem();
        fineIfsMenuItem = new javax.swing.JMenuItem();
        fineAccessMenuItem = new javax.swing.JMenuItem();
        fineMonitorMenuItem = new javax.swing.JMenuItem();
        removeFineScaleMenuItem = new javax.swing.JMenuItem();
        helpMenu = new javax.swing.JMenu();
        aboutMenuItem = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setLocationByPlatform(true);

        mapViewer.setTreeLayerVisible(true);

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(mapViewer, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 787, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, mapViewer, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 464, Short.MAX_VALUE)
        );

        fileMenu.setText("File");

        newMenuItem.setText("New project");
        newMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(newMenuItem);

        openMenuItem.setText("Open project...");
        openMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(openMenuItem);

        setLayerMenuItem.setText("Set layer...");
        setLayerMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                setLayerMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(setLayerMenuItem);

        saveMenuItem.setText("Save");
        saveMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(saveMenuItem);

        saveasMenuItem.setText("Save as...");
        saveasMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveasMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(saveasMenuItem);

        closeMenuItem.setText("Close project");
        closeMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(closeMenuItem);

        prefMenuItem.setText("Preferences");
        prefMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                prefMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(prefMenuItem);
        fileMenu.add(jSeparator1);

        exitMenuItem.setText("Exit");
        exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        largeScaleMenu.setText("Macro scale");

        largeIfsMenuItem.setText("Set the IFS");
        largeIfsMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                largeIfsMenuItemActionPerformed(evt);
            }
        });
        largeScaleMenu.add(largeIfsMenuItem);

        largeAccessMenuItem.setText("Assess the suitability of each planned centre");
        largeAccessMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                largeAccessMenuItemActionPerformed(evt);
            }
        });
        largeScaleMenu.add(largeAccessMenuItem);
        largeScaleMenu.add(jSeparator2);

        statWinMenuItem.setText("Monitor");
        statWinMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                statWinMenuItemActionPerformed(evt);
            }
        });
        largeScaleMenu.add(statWinMenuItem);

        importXmlMenuItem.setText("Import from another project");
        importXmlMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                importXmlMenuItemActionPerformed(evt);
            }
        });
        largeScaleMenu.add(importXmlMenuItem);

        menuBar.add(largeScaleMenu);

        fineScaleMenu.setText("Micro scale");

        createFineScaleMenuItem.setText("Create...");
        createFineScaleMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                createFineScaleMenuItemActionPerformed(evt);
            }
        });
        fineScaleMenu.add(createFineScaleMenuItem);

        fineIfsMenuItem.setText("Set the IFS");
        fineIfsMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fineIfsMenuItemActionPerformed(evt);
            }
        });
        fineScaleMenu.add(fineIfsMenuItem);

        fineAccessMenuItem.setText("Assess the suitability of each planned centre");
        fineAccessMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fineAccessMenuItemActionPerformed(evt);
            }
        });
        fineScaleMenu.add(fineAccessMenuItem);

        fineMonitorMenuItem.setText("Monitor");
        fineMonitorMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fineMonitorMenuItemActionPerformed(evt);
            }
        });
        fineScaleMenu.add(fineMonitorMenuItem);

        removeFineScaleMenuItem.setText("Remove");
        removeFineScaleMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeFineScaleMenuItemActionPerformed(evt);
            }
        });
        fineScaleMenu.add(removeFineScaleMenuItem);

        menuBar.add(fineScaleMenu);

        helpMenu.setText("Help");

        aboutMenuItem.setText("About...");
        aboutMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutMenuItemActionPerformed(evt);
            }
        });
        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        setJMenuBar(menuBar);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void exitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitMenuItemActionPerformed
        setVisible(false);
        dispose();
    }//GEN-LAST:event_exitMenuItemActionPerformed

    private void closeMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeMenuItemActionPerformed
        if(project.isModified()) {
            int res = JOptionPane.showConfirmDialog(this, "Do you want to save the project ?", "Closing project", JOptionPane.YES_NO_CANCEL_OPTION);
            if(res == JOptionPane.CANCEL_OPTION) {
                return;
            }
            if(res == JOptionPane.YES_OPTION) {
                saveMenuItemActionPerformed(evt);
            }
        }
        largeMonDlg.dispose();
        largeMonDlg = null;
        
        project = null;
        layers = new DefaultGroupLayer("");
        mapViewer.setRootLayer(layers);
    }//GEN-LAST:event_closeMenuItemActionPerformed

    private void saveMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveMenuItemActionPerformed

        try {
            project.save(null);
        } catch (IOException e) {
            Logger.getLogger(App.class.getName()).log(Level.SEVERE, null, e);
            JOptionPane.showMessageDialog(this, "Error while saving project !\n"+e, "Error", JOptionPane.ERROR_MESSAGE);
        }

        
    }//GEN-LAST:event_saveMenuItemActionPerformed

    private void openMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openMenuItemActionPerformed
        if(project != null) {
            closeMenuItemActionPerformed(evt);
            if(project != null) {
                return;
            }
        }
        
        File f = Util.getFile(".xml", "Project file (*.xml)");
        if(f == null) {
            return;
        }
        
        try {
            project = Project.loadProject(f);
            createLayers();
        } catch (IOException e) {
            Logger.getLogger(App.class.getName()).log(Level.SEVERE, null, e);
            JOptionPane.showMessageDialog(this, "Error while loading project !\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
        }
        
        new Thread(new Runnable() {
            @Override
            public void run() {
                project.getLargeFractal().updateAll(false);
                if(project.getFineFractal() != null) {
                    project.getFineFractal().updateAll(false);
                }
            }
        }).start();
        
    }//GEN-LAST:event_openMenuItemActionPerformed

    private void newMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newMenuItemActionPerformed
        if(project != null) {
            closeMenuItemActionPerformed(evt);
            if(project != null) {
                return;
            }
        }
        final NewProjectDialog dlg = new NewProjectDialog(this);
        dlg.setVisible(true);
        if(dlg.getReturnStatus() == NewProjectDialog.RET_CANCEL) {
            return;
        }
        
        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    TaskMonitor mon = new TaskMonitor(App.this, "Create project...", "", 0, 100);
                    mon.setMillisToDecideToPopup(0);
                    mon.setMillisToPopup(0);
                    project = Project.createProject(dlg.name, dlg.dir, dlg.buildFile, dlg.heightAttr, 
                            dlg.popFile, dlg.popAttr, mon);
                    mon.close();
                    
                } catch(IOException | SchemaException ex) {
                    Logger.getLogger(App.class.getName()).log(Level.SEVERE, null, ex);
                    JOptionPane.showMessageDialog(App.this, "Error while creating project : " + ex.getLocalizedMessage());
                }
                createLayers();
                project.getLargeFractal().forceUpdate();
            }
        }).start();
        
    }//GEN-LAST:event_newMenuItemActionPerformed

    private void aboutMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutMenuItemActionPerformed
        JOptionPane.showMessageDialog(this, getTitle() + "\n\nLaboratoire ThéMA - UBFC - CNRS\n\nGilles Vuidel - Cécile Tannier - Pierre Frankhauser");
    }//GEN-LAST:event_aboutMenuItemActionPerformed

    private void largeIfsMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_largeIfsMenuItemActionPerformed
        mapViewer.getMap().clearSelection();
        IfsEditor edit = new IfsEditor(project.getLargeFractal().getIfs());
        edit.setLocationRelativeTo(this);
        edit.setVisible(true);
    }//GEN-LAST:event_largeIfsMenuItemActionPerformed

    private void statWinMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_statWinMenuItemActionPerformed
        largeMonDlg.setVisible(true);
    }//GEN-LAST:event_statWinMenuItemActionPerformed

    private void fineIfsMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fineIfsMenuItemActionPerformed
        mapViewer.getMap().clearSelection();
        IfsEditor edit = new IfsEditor(project.getFineFractal().getIfs());
        edit.setLocationRelativeTo(this);
        edit.setVisible(true);
    }//GEN-LAST:event_fineIfsMenuItemActionPerformed

    private void createFineScaleMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_createFineScaleMenuItemActionPerformed
        final List<? extends SelectableShape> sel = mapViewer.getMap().getSelection();
        if(sel.isEmpty() || !(sel.get(0) instanceof FractalElemShape)) {
            JOptionPane.showMessageDialog(this, "You have to select a fractal element to define zone.");
            return;
        }
        
        if(project.getFineFractal() != null) {
            int res = JOptionPane.showConfirmDialog(this, "A fine scale fractal already exist. Do you want to replace it ?");
            if(res != JOptionPane.YES_OPTION) {
                return;
            }
        }
            
        new Thread(new Runnable() {
            @Override
            public void run() {
                FractalElem elem = ((FractalElemShape)sel.get(0)).getFeature();
                try {
                    project.createFineScale(elem);
                    project.setCurrentFractal(project.getFineFractal());
                    addFineScaleLayers();
                    project.getFineFractal().forceUpdate();

                } catch (Exception ex) {
                    Logger.getLogger(App.class.getName()).log(Level.SEVERE, null, ex);
                    JOptionPane.showMessageDialog(App.this, "An error has occured : \n" + ex.getLocalizedMessage());
                }
            }
        }).start();
        
    }//GEN-LAST:event_createFineScaleMenuItemActionPerformed

    private void removeFineScaleMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeFineScaleMenuItemActionPerformed
        layers.removeLayer(fineScaleLayers);
        largeScaleLayers.setVisible(true);
        largeScaleLayers.setExpanded(true);
        project.setCurrentFractal(project.getLargeFractal());
        project.removeFineScale();
        fineMonDlg.dispose();
    }//GEN-LAST:event_removeFineScaleMenuItemActionPerformed

    private void fineMonitorMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fineMonitorMenuItemActionPerformed
        fineMonDlg.setVisible(true);
    }//GEN-LAST:event_fineMonitorMenuItemActionPerformed

    private void fineAccessMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fineAccessMenuItemActionPerformed
        AccessibilitiesDialog dlg = new AccessibilitiesDialog(this, project.getFineAccess());
        dlg.setVisible(true);
        
        new Thread(new Runnable() {
            @Override
            public void run() {
                project.getFineFractal().updateEval(project.getFineAccess(), false);
                refreshStat();
            }
        }).start();
    }//GEN-LAST:event_fineAccessMenuItemActionPerformed

    private void largeAccessMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_largeAccessMenuItemActionPerformed
        AccessibilitiesDialog dlg = new AccessibilitiesDialog(this, project.getLargeAccess());
        dlg.setVisible(true);

        new Thread(new Runnable() {
            @Override
            public void run() {
                project.getLargeFractal().updateEval(project.getLargeAccess(), false);
                refreshStat();
            }
        }).start();
        
    }//GEN-LAST:event_largeAccessMenuItemActionPerformed

    private void setLayerMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_setLayerMenuItemActionPerformed
        final SetLayerDialog dlg = new SetLayerDialog(this, project);
        dlg.setVisible(true);
        if(!dlg.isOk) {
            return;
        }
        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    if(dlg.layer == null) {
                        project.addInfoLayer(dlg.file);
                        layers.addLayerLast(new ShapeFileLayer(dlg.file));
                    } else {
                        boolean isExist = project.isLayerExist(dlg.layer.getName());
                
                        project.setLayer(dlg.layer, dlg.file, dlg.attrs);
                        project.getLargeFractal().updateAll(false);
                        if(project.getFineFractal() != null) {
                            project.getFineFractal().updateAll(false);
                        }
                        if(!isExist) {
                            Layer l = new FeatureLayer(dlg.layer.getDesc(), project.getLayerFeatures(dlg.layer.getName()), 
                                    project.getLargeFractal().getFractalLayer().getBounds(), dlg.layer.getStyle());
                            l.setVisible(false);
                            l.setRemovable(true);
                            layers.addLayerLast(l); 
                        }
                    }
                    
                } catch (IOException ex) {
                    Logger.getLogger(SetLayerDialog.class.getName()).log(Level.SEVERE, null, ex);
                    JOptionPane.showMessageDialog(App.this, "An error occured : \n" + ex);
                }
            }
        }).start();
        
    }//GEN-LAST:event_setLayerMenuItemActionPerformed

    private void prefMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_prefMenuItemActionPerformed
        PreferencesDialog dlg = new PreferencesDialog(this, true);
        dlg.setProcPanelVisible(true);
        dlg.setVisible(true);
    }//GEN-LAST:event_prefMenuItemActionPerformed

    private void saveasMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveasMenuItemActionPerformed
        File f = Util.getFileSave(".xml");
        if(f == null) {
            return;
        }
        try {
            project.save(f.getName());
            layers.setName(project.getName() + " - " + project.getProjectFile().getName());
        } catch (IOException e) {
            Logger.getLogger(App.class.getName()).log(Level.SEVERE, null, e);
            JOptionPane.showMessageDialog(this, "Error while saving project !\n"+e, "Error", JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_saveasMenuItemActionPerformed

    private void importXmlMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_importXmlMenuItemActionPerformed
        File f = Util.getFile(".xml", "Project file (*.xml)");
        if(f == null) {
            return;
        }
            
        try {
            project.importFractal(f);
            createLayers();
        } catch (IOException ex) {
            Logger.getLogger(App.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_importXmlMenuItemActionPerformed
    
    private void createLayers() {
        if(largeMonDlg != null) {
            largeMonDlg.dispose();
        }
        largeMonDlg = new StatInfoDialog(this, mapViewer, project.getLargeFractal());
        largeMonDlg.setVisible(true);
        
        layers = new DefaultGroupLayer(project.getName() + " - " + project.getProjectFile().getName(), true) {
            @Override
            public boolean removeLayer(Layer l) {
                boolean remove = super.removeLayer(l); 
                if(remove) {
                    for(LayerDef def : Project.LAYERS) {
                        if(l.getName().equals(def.getDesc())) {
                            new File(project.getDirectory(), def.getName() + ".shp").delete();
                            new File(project.getDirectory(), def.getName() + ".shx").delete();
                            new File(project.getDirectory(), def.getName() + ".dbf").delete();
                            new File(project.getDirectory(), def.getName() + ".prj").delete();
                            new File(project.getDirectory(), def.getName() + ".fix").delete();
                        }
                    }
                }
                return remove;
            }
            
        };
        largeScaleLayers = new DefaultGroupLayer("Macro scale", true);
        largeScaleLayers.addLayerLast(project.getLargeFractal().getFractalGroupLayer());
        layers.addLayerFirst(largeScaleLayers);
        addFineScaleLayers();
        
        Rectangle2D bounds = project.getLargeFractal().getFractalLayer().getBounds();
        Layer l = new FeatureLayer("Buildings", project.getLayerFeatures(Layers.BUILD.toString()), bounds, new FeatureStyle(Color.black, Color.black));
        l.setVisible(false);
        layers.addLayerLast(l); 
        l = new FeatureLayer("Housing units", project.getLayerFeatures(Layers.HOUSING.toString()), bounds, new FeatureStyle(null, Color.black));
        l.setVisible(false);
        layers.addLayerLast(l);
        for(LayerDef def : Project.LAYERS) {
            if(project.isLayerExist(def.getName())) {
                l = new FeatureLayer(def.getDesc(), project.getLayerFeatures(def.getName()), bounds, def.getStyle());
                l.setVisible(false);
                l.setRemovable(true);
                layers.addLayerLast(l); 
            }
        }
        try {
            RasterStyle style = new RasterStyle(new UniqueColorTable(Arrays.asList(1.0), Arrays.asList(Color.black)));
            style.setNoDataValue(0);
            layers.addLayerLast(new RasterLayer("Buildings", new CoverageShape(project.getBuildRaster(), style)));
        } catch (IOException ex) {
            Logger.getLogger(App.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        if(!project.getInfoLayers().isEmpty()) {
            DefaultGroupLayer infoLayer = new DefaultGroupLayer("Additional layers");
            for(ShapeFileLayer ls : project.getInfoLayers()) {
                infoLayer.addLayerFirst(ls);
            }
            layers.addLayerLast(infoLayer);
        }
        
        mapViewer.setRootLayer(layers);
        
        // mise à jour des fonctions limites et overlap dans le nouveau fractal layer
        overlapAction.actionPerformed(null);
        limitAction.actionPerformed(null);
        
    }
    
    private void addFineScaleLayers() {
        if(project.getFineFractal() == null) { 
            return;
        }
        
        fineMonDlg = new StatInfoDialog(this, mapViewer, project.getFineFractal());
        fineMonDlg.setVisible(true);
        
        fineScaleLayers = new DefaultGroupLayer("Micro scale", true);
        fineScaleLayers.addLayerFirst(project.getFineFractal().getFractalGroupLayer());
      
            
        if(!project.isLargeCurrent()) {
            largeScaleLayers.setVisible(false);
            largeScaleLayers.setExpanded(false);
            largeMonDlg.setVisible(false);
        } else {
            fineScaleLayers.setVisible(false);
            fineScaleLayers.setExpanded(false);
            fineMonDlg.setVisible(false);
        }
        
        layers.addLayerFirst(fineScaleLayers);
        
        // mise à jour des fonctions limites et overlap dans le nouveau fractal layer
        overlapAction.actionPerformed(null);
        limitAction.actionPerformed(null);
    }
    
    private long timeStamp = 0;
    private boolean evtIgnored = false;
//    private Timer timer = new Timer();
//    private TimerTask task = null;
    public void refreshStat() {
        long t = System.currentTimeMillis();
        if(t-timeStamp > 100) {
            largeMonDlg.refreshStat();
            if(fineMonDlg != null) {
                fineMonDlg.refreshStat();
            }
            mapViewer.updateInfoPanel();
            timeStamp = System.currentTimeMillis();
            evtIgnored = false;
        } else {
            evtIgnored = true;
//            if(task != null) {
//                task.cancel();
//            }
//            timer.purge();
//            task = new TimerTask() {
//                @Override
//                public void run() {
//                    if(evtIgnored) {
//                        refreshStat();
//                    }
//                }
//            };
//            timer.schedule(task, 1000);
        }
        
    }
    
    
    private final AbstractAction overlapAction = new AbstractAction("Overlap") {
        @Override
	public void actionPerformed(ActionEvent e) {
	    project.getLargeFractal().getFractalLayer().setVerifyOverlap(overlapToggleButton.isSelected());
            if(project.getFineFractal() != null) {
                project.getFineFractal().getFractalLayer().setVerifyOverlap(overlapToggleButton.isSelected());
            }
        }
    };
    private final AbstractAction limitAction = new AbstractAction("Limit") {
        @Override
	public void actionPerformed(ActionEvent e) {
	    project.getLargeFractal().getFractalLayer().setVerifyParentLimit(limitToggleButton.isSelected());
            if(project.getFineFractal() != null) {
                project.getFineFractal().getFractalLayer().setVerifyParentLimit(limitToggleButton.isSelected());
            }
	}
    };
    
    private final AbstractAction editShapeAction = new AbstractAction("Edit shape") {
        @Override
	public void actionPerformed(ActionEvent e) {
	    for(SelectableShape s : App.this.mapViewer.getMap().getSelection()) {
                if(s instanceof FractalElemShape) {
                    FractalElemShape fractalShape = (FractalElemShape)s;
                    EditShapeDialog editor = new EditShapeDialog(App.this, fractalShape, App.this.mapViewer.getMap());
                    editor.setVisible(true);
                    if(!editor.isOk) {
                        return;
                    }
                    
                    Polygon poly = editor.getScaledPolygon();                    
                    fractalShape.setShape(new AffineTransform().createTransformedShape(new LiteShape(poly, null, false)));
                    
                    return;
                }
                
            }
	}
    };

    /**
     * Main entry point of Fractalopolis software.
     * 
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        Config.setNodeClass(App.class);
        Locale.setDefault(Locale.ENGLISH);
        try {
            if(args.length == 0) {
                if (JavaLoader.forkJava(App.class, 1500)) {
                    return;
                }
            }
        } catch (Exception ex) {
            Logger.getLogger(App.class.getName()).log(Level.SEVERE, null, ex);
        }
       
        // Catch all uncaught exceptions and show a message
        Thread.setDefaultUncaughtExceptionHandler(new Thread.UncaughtExceptionHandler() {
            @Override
            public void uncaughtException(Thread t, Throwable e) {
                if(e instanceof CancellationException) {
                    JOptionPane.showMessageDialog(null, "Execution has been cancelled");
                } else {
                    Logger.getLogger("").log(Level.SEVERE, null, e);
                    JOptionPane.showMessageDialog(null, "An error has occurred : " + e);
                }
            }
        });
       
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex) {
            Logger.getLogger(App.class.getName()).log(Level.WARNING, null, ex);
        }
        
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                mainFrame = new App();
                mainFrame.setVisible(true);
            }
        });
    }

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem aboutMenuItem;
    private javax.swing.JMenuItem closeMenuItem;
    private javax.swing.JMenuItem createFineScaleMenuItem;
    private javax.swing.JMenuItem exitMenuItem;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JMenuItem fineAccessMenuItem;
    private javax.swing.JMenuItem fineIfsMenuItem;
    private javax.swing.JMenuItem fineMonitorMenuItem;
    private javax.swing.JMenu fineScaleMenu;
    private javax.swing.JMenu helpMenu;
    private javax.swing.JMenuItem importXmlMenuItem;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JPopupMenu.Separator jSeparator2;
    private javax.swing.JMenuItem largeAccessMenuItem;
    private javax.swing.JMenuItem largeIfsMenuItem;
    private javax.swing.JMenu largeScaleMenu;
    private org.thema.drawshape.ui.MapViewer mapViewer;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JMenuItem newMenuItem;
    private javax.swing.JMenuItem openMenuItem;
    private javax.swing.JMenuItem prefMenuItem;
    private javax.swing.JMenuItem removeFineScaleMenuItem;
    private javax.swing.JMenuItem saveMenuItem;
    private javax.swing.JMenuItem saveasMenuItem;
    private javax.swing.JMenuItem setLayerMenuItem;
    private javax.swing.JMenuItem statWinMenuItem;
    // End of variables declaration//GEN-END:variables


    
}
